<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr">
<head>
  <title>Crawler interne</title>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />
  <meta name="author" content="Tony Archambeau" />
<style type="text/css">
body{
margin:0;
}
#header{
padding:10px;
font-size:2em;
background-color:#ccc;
border-bottom:1px solid #dedede;
}

#content{
margin:4px;
padding:4px;
border:1px solid #dedede;
}
.fenetre{
max-height:100px;
margin:4px;
margin-left:35px;
margin-right:20px;
padding:2px;
background-color:#000;
color:#fff;
overflow:auto;
font-family:monospace;
}

#footer{
padding:4px;
background-color:#444;
color:#aaa;
border-top:1px solid #dedede;
}
#footer a{
color:#fff;
}
</style>
</head>
<body>

<div id="global">
	<div id="header">
		Crawler interne
	</div><!-- END:#header -->

	<div id="container">
		<div id="content">
<?php
//****
// dtecte l'extension d'un fichier et retourne cette extension
function detect_extension($filename)
{
	$array = explode('.', $filename);
	return $array[count($array)-1];
}


//****
// lister les fichiers prsent sur le serveur d'un site web
function lister_fichier($array_repertoire=Array(), $espacement='', $nbr_fichier=0, $aray_extension_ignorer=Array())
{
	// Dfinir le rpertoire  crawler
	if (count($array_repertoire)!=0) {
		$repertoire_a_visiter = implode('/', $array_repertoire);
		$repertoire_pour_html = implode('/', $array_repertoire).'/';
	} else {
		$repertoire_a_visiter = '.';
		$repertoire_pour_html = '';
	}
	
	if ($handle = opendir($repertoire_a_visiter)) { // Ouvrir un rpertoire
		$liste_fichier_dossier = Array();
		
		while (false !== ($file = readdir($handle))) {
			if ($file != "." && $file != "..")
				$liste_fichier_dossier[] = $file;
		}
		sort($liste_fichier_dossier); // trier le tableau
		
		//****
		// D'abord lister les dossiers
		foreach($liste_fichier_dossier as $element) {
			if (@filetype($repertoire_pour_html.$element)=='dir') { // vrifier si l'lment est un dossier
				$array_repertoire[] = $element;
				
				echo $espacement.' + <a href="'.$repertoire_pour_html.$element.'/">'.$element.'/</a><br />'."\n";
				
				// Incrment l'espace puis entre dans une nouvelle boucle puisqu'il s'agit d'un dossier
				$espacement .= '....';
				echo $espacement.' - '.lister_fichier($array_repertoire, $espacement, $nbr_fichier, $aray_extension_ignorer).'<br />';
				
				// Retour sur le prcdent dossier (donc mise  jour: espacement + repertoire)
				$espacement = substr($espacement, 0, -4);
				array_splice($array_repertoire, count($array_repertoire)-1);
			}
		}
		
		//****
		// Ensuite lister les fichiers
		foreach($liste_fichier_dossier as $element) {
			if (@filetype($repertoire_pour_html.$element)=='file') { // vrifier si l'lment est un fichier
				$nbr_fichier++; // incrment le nombre de fichier
				
				// lister uniquement les extension non ignores
				$ignorer_extension=false;
				foreach ($aray_extension_ignorer as $extension_a_ignorer) {
					if (detect_extension($element)==$extension_a_ignorer)
						$ignorer_extension=true;
				}
				
				if (!$ignorer_extension) // si l'extension n'est pas ignorer, alors afficher l'lment
					echo $espacement.' - <a href="'.$repertoire_pour_html.$element.'">'.$element.'</a><br />'."\n";
			}
		}
		
		closedir($handle);
	}
	
	return '( '.$nbr_fichier.' files )';
}


// liste des extensions  ignorer. Permet par exemple, d'viter de prsenter une norme liste d'images.
// pour lister tous les types de fichiers, il suffit de vider ce tableau
$aray_extension_ignorer = array('bmp', 'BMP', 'doc', 'DRC', 'exe', 'gif', 'ico', 'jpg', 'JPG', 'NET', 'odp', 'ods', 'odt', 'ots', 'LYT', 'PCB', 'pdf', 'png', 'ppt', 'rar', 'SCH', 'SDF', 'TNG', 'txt', 'wav', 'WAV', 'xml', 'xls');


// Utiliser le script
echo lister_fichier(Array(), '', 0, $aray_extension_ignorer);


?>
		</div><!-- END:#content -->
	</div><!-- END:#container -->

	<div id="footer">
		<a rel="license" href="http://creativecommons.org/licenses/by/2.0/fr/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by/2.0/fr/80x15.png" /></a><br />Cette cr&#233;ation par <a xmlns:cc="http://creativecommons.org/ns#" href="http://tonyarchambeau.com/blog/" property="cc:attributionName" rel="cc:attributionURL">Tony Archambeau</a> est mise &#224; disposition selon les termes de la <a rel="license" href="http://creativecommons.org/licenses/by/2.0/fr/">licence Creative Commons Paternit&#233; 2.0 France</a>.
	</div><!-- END:#footer -->
</div><!-- END:#global -->

</body>
</html>